#!/usr/bin/perl
#
#  Wrapper script for searching with htdig.
#
#  This file is part of the SuSE help system.
#
#  Copyright (C) 2002  SuSE Linux AG, Nuernberg
#
#  Author: Cornelius Schumacher <cschum@suse.de>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use FindBin;
use lib $FindBin::Bin;

use utf8;
use open IO => ':utf8';
use open ':std';

use susehelp;

use Encode;

&checkQuery;
&parseQuery;

$lang = lc getQuery( "lang", "en" );
$charset = langCharset( $lang );

&dbg( "charset: $charset" );

$words = getQuery( "stichwort" );
$searchtype = getQuery( "searchtype" );

$words = encode( $charset, $words );

$ENV{ "QUERY_STRING" } = "stichwort=$words&searchtype=$searchtype";

$sdbbin = "$susehelp::cgidir/sdbsearch_$lang.cgi";

&dbg( "sdbbin: $sdbbin" );

if ( !open( SDBSEARCH, "$sdbbin|iconv -f $charset -t utf8 |" ) ) {
  print "Can't execute sdbsearch.\n";
  exit 1;
}

print "<body>\n";

while( <SDBSEARCH> ) {
  if ( /^<LI>.*<A HREF=\"(.*)\">(.*)<\/A>/ ) {
    print "<li><a href=\"/usr/share/doc$1\">$2</a></li>\n";
  } elsif ( /^(<H3>|<ul>|<\/ul>)(.*)/ ) {
    print;
  }
}

close SDBSEARCH;

print "</body>\n";

exit $?;
